
<script src="{{ url_for('static', filename='vendor/easymde/easymde.min.js') }}"></script>
<script src="/static/vendor/dompurify/purify.2.4.0.min.js"></script>
<link rel="stylesheet" type="text/css" href="{{ url_for('static', filename='vendor/easymde/easymde.min.css') }}">
<link rel="stylesheet" type="text/css" href="{{ url_for('static', filename='vendor/font-awesome/font-awesome.min.css') }}">

{% include 'common/insert-link-modal.html' %}

{% set consent_placeholders = consent.placeholders() %}
{% set label_examples = consent.label_examples() %}


  <div class="grid mt-3 ds-wrapper-white">
    <div class="g-col-12 pt-1">
      <form name="consent-form" action="{{ post_action }}" method="post">
        <input type="hidden" name="csrf_token" value="{{ csrf_token() }}" />
        {{ wtform.wizard(id="wizard_data") }}
        {{ wtform.required(id="consent-required") }}
        <div class="form-group">
          {{ wtform.name.label(for="consent-name", class_="form-label") }}<span class="ds-required" arial-label="required"></span>
          {{ wtform.name(id="consent-name", class_="form-control") }}
          {% for error in wtform.name.errors %}
            <span class="wtf-error ds-error-message">{{ error }}</span>
          {% endfor -%}
        </div>

        {% if consent.id  and consent.site_id %}
        <div class="mt-4">
          {% include 'consent/partials/site-consent-options.html' %}
        </div>
        {% endif %}

        {% set hide_selector = not (g.site.custom_languages|length > 1 and scope == "site") %}
        <div class="form-group mt-4" {% if hide_selector %}style="display:none"{%endif%}>
          {{ wtform.language_selector.label(for="language", class_="form-label") }}
          {{ wtform.language_selector(id="lang_selector", class_="form-select", onchange="selectLanguage()") }}
        </div>
        {{ wtform.language(id="language") }}

        <div class="form-group mt-4">
          {{ wtform.label.label(for="consent-label", class_="form-label") }}
          {{ wtform.label(id="consent-label",
                          class_="form-control",
                          placeholder=label_examples[wtform.language.data]) }}
          {% for error in wtform.label.errors %}
            <span class="wtf-error ds-error-message">{{ error }}</span>
          {% endfor %}
        </div>

        <div class="form-group mt-4">
          {{ wtform.md_text.label(for="consent-title", class_="form-label", for="md-editor") }}<span class="ds-required" arial-label="required label"></span>
          {% if wizard_url %}
          <br />
          {% set wizard_link = '<a href="#" onclick="go_to_wizard(); return false">%s</a>' %  _("Wizard") %}
          <label class="form-label">{{ _("Need some help? Try the %(wizard)s", wizard=wizard_link|safe) }}.</label>
          {% endif %}
          <textarea id="md-editor" name="md_text" required></textarea>
          {% for error in wtform.md_text.errors %}
            <span class="wtf-error ds-error-message">{{ error }}</span>
          {% endfor %}
        </div>

        <div class="form-group mt-4 form-row">
          {{ wtform.checkbox_label.label(for="checkbox-label", class_="form-label") }}
          <div class="input-group">
            {{ wtform.checkbox_label(id="checkbox-label",
                                    class_="form-control",
                                    placeholder=consent_placeholders[wtform.language.data]) }}
            <div id="toggle_consent_required" class="btn-group btn-toggle">
              <button id="consent_required_true" type="button" class="toggle-required btn btn-sm {% if wtform.required.data %} btn-primary {% else %} btn-outline-secondary {% endif %}">{{ _("Required") }}</button>
              <button id="consent_required_false" type="button" class="toggle-required btn btn-sm {% if not wtform.required.data %} btn-primary {% else %} btn-outline-secondary {% endif %}">{{ _("Optional") }}</button>
            </div>
          </div>
        </div>

        {% if scope == "form" and not (consent.id or template) %}
        <div class="form-group form-check mt-4">
          <input id="library_checkbox" class="form-check-input" type="checkbox" name="add-to-library" value=true />
          <label for="library_checkbox" class="form-check-label mb-0">{{ _("Add this statement to my library") }}</label>
        </div>
        {% endif %}

        <div class="mt-4">
          <button type="button" class="btn btn-outline-primary" onclick="showPreview()">{{ _("Preview")}}</button>
          {% if scope == "form" %}
            {% set form_count = 0 %}
          {% else %}
            {% if consent.enforced %}
              {% set form_count = Form.count() %}
            {% elif consent.id %}
              {% set form_count = FormConsent.find_all(consent_id=consent.id).count() %}
            {% else %}
              {% set form_count = 0 %}
            {% endif %}
          {% endif %}
          <input id="save-edit" class="btn btn-primary" type="button" value="{%if form_count > 0%}{{_('Save and update all forms')}}{%else%}{{_('Save')}}{%endif%}" />
        </div>
      </form>
    </div>
  </div>

  <div id="preview-container" class="grid mt-4 ds-wrapper-white" style="display:none">
    <div class="g-col-12">
      <div id="consent-preview" class="mb-0"></div>
    </div>
  </div>


{% include('consent/partials/consent_forms_modal.html') %}

<script>

var consent_labels = {{ consent.label | tojson}}
var label_examples = {{ label_examples | tojson}}
var consent_texts = {{ consent.text | tojson}}
var checkbox_labels = {{ consent.checkbox_label | tojson}}
var placeholders = {{ consent_placeholders | tojson}}
var lang_code = "{{ wtform.language.data }}"
var form = null
var easymde = null
var session_wizard = null

// Parsely validation
form = $("form[name=consent-form]")
const parsley_options = {
  errorsContainer: function (field) {
    return $(field.element).closest(".form-group")
  }
}
form.parsley(parsley_options).on('field:validate', function(field) {
  $(field.element).closest('div').find('.wtf-error').remove()
})

function ensureLangCodeKey(_lang_code) {
  if (!Object.keys(consent_texts).includes(_lang_code)) {
    consent_texts[_lang_code] = {"markdown": ""}
  }
  if (!Object.keys(consent_labels).includes(_lang_code)) {
    consent_labels[_lang_code] = ""
  }
  if (!Object.keys(checkbox_labels).includes(_lang_code)) {
    checkbox_labels[_lang_code] = ""
  }
}

{% if scope != "site" -%}
{#
// Preventative measure only.
// The user may possibly have changed their profile language since last saving this consent.
// Let's find previous saved consent (if any) and move it to their new user.profile lang_code
-#}
if (!Object.keys(consent_texts).includes(lang_code)) {
  for (const _lang_code of Object.keys(consent_texts)) {
    if (Object.keys(consent_texts).includes(_lang_code) &&
        consent_texts[_lang_code]["markdown"] !== undefined &&
        consent_texts[_lang_code]["markdown"] !== "") {
      consent_texts[lang_code] = consent_texts[_lang_code]
      consent_labels[lang_code] = consent_labels[_lang_code]
      break
    }
  }
}
{% endif -%}

$(function() {
  // Recover the data stored in the crumb set by go_to_wizard()
  //
  var storage_key = "consent_" +  "{{consent.id if consent.id else ''}}"
  var consent_crumb = window.sessionStorage.getItem(storage_key)
  //console.log("storage_key", storage_key)
  window.sessionStorage.removeItem(storage_key)
  if (consent_crumb !== null) {
    let cleaned_data = DOMPurify.sanitize(consent_crumb, { USE_PROFILES: { html: true } });
    consent_crumb = JSON.parse(cleaned_data)
    {% if scope == "site" %}
      lang_code = consent_crumb.language
      $("#language").val(lang_code)
    {% else %}
      lang_code = "{{ wtform.language.data }}"
    {% endif %}
    ensureLangCodeKey(lang_code)
    consent_texts[lang_code]["markdown"] = consent_crumb.markdown
    consent_labels[lang_code] = consent_crumb.label
    checkbox_labels[lang_code] = consent_crumb.checkbox_label
    $("#consent-name").val(consent_crumb.name)
  }
  ensureLangCodeKey(lang_code)

  {#
  // wizard saves this data to sessionStorage when the Copy button is clicked
  // load the form with the values (this overides crumb values)
  -#}
  storage_key = "wizard_" + "{{consent.id if consent.id else ''}}"
  session_wizard = window.sessionStorage.getItem(storage_key)
  //console.log("storage_key", storage_key)
  window.sessionStorage.removeItem(storage_key)
  if (session_wizard !== null) {
    let cleaned_data = DOMPurify.sanitize(session_wizard, { USE_PROFILES: { html: true } });
    wizard = JSON.parse(cleaned_data)
    consent_texts[lang_code]["markdown"] = wizard.generated_text
    $("#wizard_data").val(JSON.stringify(wizard.wizard))
  }
  // finished loading form values
  $("#language").val(lang_code)
  $("#lang_selector").val(lang_code)

  // create md editor
  const editor_toolbar = [
      "bold",
      "italic",
      "heading",
      "|", // Separator
      "unordered-list",
      "ordered-list",
      "|",
      {
        name: "custom",
        action: function customLink(editor){
          $('#insert_link_form')[0].reset();
          $('#insert_link_modal').modal('show');
        },
        className: "fa fa-link",
        title: "Link",
      },
      "|", // Separator
      "preview",
      "guide"
  ];
  easymde = new EasyMDE({
                  toolbar: editor_toolbar,
                  autosave: {enabled: false},
                  // autofocus: true,
                  spellChecker: false,
                  maxHeight: "150px",
                  forceSync: true,
                  status: false,
                  autoDownloadFontAwesome: false,
                  element: $("#md-editor")[0]
  });
  renderFormValues()
  // page ready
});

function selectLanguage() {
  {#
  // #lang_selector is only available when scope == site.
  // #language.val is our reference
  -#}
  $('#language').val($('#lang_selector').val())
  changeLanguage()
}
function changeLanguage() {
  // load current form values into old lang_code
  consent_texts[lang_code]['markdown'] = easymde.value()
  consent_labels[lang_code] = $("#consent-label").val()
  checkbox_labels[lang_code] = $("#checkbox-label").val()
  // change lang_code
  lang_code = $('#language').val()
  ensureLangCodeKey(lang_code)
  renderFormValues()
}
function renderFormValues() {
  // load the form with lang_code values
  $("#consent-label").prop("placeholder", label_examples[lang_code])
  $("#consent-label").val(consent_labels[lang_code])
  easymde.value(consent_texts[lang_code]['markdown'])
  $("#checkbox-label").prop("placeholder", placeholders[lang_code])
  $("#checkbox-label").val(checkbox_labels[lang_code])
  if ($("#preview-container").is(':visible')) {
    updatePreview()
  }
}

function go_to_wizard() {
  // set crumb data. This data will be recovered when we return to this page
  let storage_key = "consent_" + "{{consent.id if consent.id else ''}}"
  window.sessionStorage.setItem(storage_key, JSON.stringify({
      name: $("#consent-name").val(),
      label: $("#consent-label").val(),
      title: $("#consent-title").val(),
      markdown: easymde.value(),
      checkbox_label: $("#checkbox-label").val(),
      language: $("#language").val(),
  }));
  // goto wizard page
  window.location = "{{wizard_url}}"
}

$(document).ready(function() {
  $("#save-edit").click(function(){
    if (form.parsley().validate()) {
      form.submit();
    }
  });
  $("form[name=consent-form]").focusin(function() {
    if (! $("#save-edit").is(':focus')) {
      clearPreview()
    }
  });
});

document.getElementById('toggle_consent_required').addEventListener('click', function(evt){
  if ($("#consent-required").val() == "False") {
    $("#consent-required").val("True")
    $('#consent_required_true').addClass('btn-primary').removeClass('btn-outline-secondary');
    $('#consent_required_false').removeClass('btn-primary').addClass('btn-outline-secondary');
  } else {
    $("#consent-required").val("False")
    $('#consent_required_true').removeClass('btn-primary').addClass('btn-outline-secondary');
    $('#consent_required_false').addClass('btn-primary').removeClass('btn-outline-secondary');
  }
  clearPreview()
});

function showPreview() {
  updatePreview()
  $("#preview-container").show()
}
function clearPreview() {
  $("#preview-container").hide()
  $("#consent-preview").html("")
}
function updatePreview() {
  $.ajax({
      url : "{{url_for('consent_bp.get_preview')}}",
      type: "POST",
      data : {
        lang_code: lang_code,
        label: $("#consent-label").val(),
        md_text: easymde.value(),
        checkbox_label: $("#checkbox-label").val(),
        required: $("#consent-required").val(),
      },
      dataType: "json",
      beforeSend: function(xhr, settings) {
        if (!/^(GET|HEAD|OPTIONS|TRACE)$/i.test(settings.type)) {
            xhr.setRequestHeader("X-CSRFToken", csrftoken)
        }
      },
      success: function(data, textStatus, jqXHR)
      {
        $("#consent-preview").html(data.html)
        $('html, body').animate({
            scrollTop: $("#consent-preview").offset().top -200
        }, 250);
      }
  });
}

// display forms using this consent
function showFormsWithConsentModal(consent_id) {
  $.ajax({
    url : "/data-consent/{{scope}}/"+consent_id+"/forms",
    type: "GET",
    dataType: "json",
    beforeSend: function(xhr, settings) {
      if (!/^(GET|HEAD|OPTIONS|TRACE)$/i.test(settings.type)) {
        xhr.setRequestHeader("X-CSRFToken", csrftoken)
      }
    },
    success: function(data, textStatus, jqXHR)
    {
      $("#form_list").html("")
      data.forms.forEach(form => {
        if ("{{scope}}" == "site") {
          $("#form_list").append("<li><a href='"+form.url+"'>"+form.slug+"</a></li>")
        }
        if ("{{scope}}" == "user" || "{{scope}}" == "form") {
          $("#form_list").append("<li><a href='"+form.url+"'>"+form.name+"</a></li>")
        }
      });
      $("#form-list-modal").modal("show")
    }
  });
}

// md editor insert link function
$(document).on("insert_link", function(event, form_id) {
  $('.modal').modal('hide');
  var link_url = $('#'+form_id).find('input[name=link_url]').val();
  if (link_url === '') {
    link_url = 'https://'
  }
  var link_text = $('#'+form_id).find('input[name=link_text]').val();
  if (link_text === '') {
    link_text = link_url
  }
  if ($('form[name=consent-form]').find(".CodeMirror-selectedtext").length) {
    easymde.codemirror.replaceSelection('['+link_text+']('+link_url+')');
  } else {
    let pos = easymde.codemirror.getCursor();
    easymde.codemirror.replaceRange(' ['+link_text+']('+link_url+') ', pos);
  }
  return false;
});
</script>
